import { Server } from 'socket.io'
import { TSocket } from '../utilities/types'
import CharacterManager from '../managers/characterManager'

export default function (socket: TSocket, io: Server) {
  socket.on('disconnect', async (data: any) => {
    if (!socket.user) {
      console.log('User disconnected but had no user set')
      return
    }

    io.emit('user:disconnect', socket.user.id)

    const character = CharacterManager.getCharacterFromSocket(socket);

    if (!character) {
      console.log('User disconnected but had no character set')
      return
    }

    console.log('User disconnected along with their character')

    await CharacterManager.removeCharacter(character)

    io.in(character.zoneId.toString()).emit('zone:character:leave', character.id)
    io.emit('character:disconnect', character.id)
  })
}
